annotation-app/app/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('reposynergy/', include('reposynergy.urls')),
    path('admin/', admin.site.urls),
]

annotation-app/reposynergy/urls.py
from django.urls import path

from . import views

app_name = "reposynergy"
urlpatterns = [
    path('', views.index, name='index'),
    path('login', views.login, name='login'),
    path('logout', views.logout, name='logout'),
    path('dashboard', views.dashboard, name='dashboard'), # redirects the annotator to the guideline + all repos to annotate
    path('annotate/<str:pair_id>/', views.annotate, name='annotate'), # redirects to the next repo pairs - shows readme files and the questions+
    path('save_annotation', views.save_annotation, name='save_annotation'),
    path('upload_repopairs', views.upload_repopairs, name='upload_repopairs'),
    path('create_show_users', views.create_show_users, name='create_show_users'),
    path('download_annotations', views.download_annotations, name='download_annotations'),
    path('download_users', views.download_users, name='download_users'),
    path('download_repo_pairs', views.download_repo_pairs, name='download_repo_pairs'),
]

annotation-app/reposynergy/models.py
from django.db import models

from django.contrib.auth.models import AbstractUser
from datetime import datetime
from django.db.models import Count
from django.core.exceptions import ObjectDoesNotExist

class User(AbstractUser):
    batch =  models.IntegerField( null=True)
    def getUser(email):
        return User.objects.filter(username=email)

class RepositoryPair(models.Model):
    id = models.BigAutoField(primary_key=True)

    repo_url1 = models.CharField(max_length=250,null=False)
    repo_url2 = models.CharField(max_length=250,null=False)

    repo_description1 =models.CharField(max_length=2000,null=False)
    repo_description2 = models.CharField(max_length=2000,null=False)

    score = models.FloatField(default=0.0)
    is_random = models.BooleanField(default=False)

    algorithm = models.CharField(max_length=20, null=True)
    batch = models.IntegerField(null=True)

    def getRepoPairs(self):
        return RepositoryPair.objects.all()

    def getBatchRepoPairs(self, batch):
        return RepositoryPair.objects.filter(batch=batch)

    def getRepoPair(self, pair_id):
        return RepositoryPair.objects.get(pk=pair_id)

class Annotation(models.Model):
    a_id = models.AutoField(primary_key=True)
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    repository_pair = models.ForeignKey(RepositoryPair, on_delete=models.CASCADE)

    annotation_date = models.DateTimeField(default=datetime.now)
    synergy = models.IntegerField( null=False)  # good:2 acceptable:1 poor:0
    direction = models.IntegerField(null=False)  # good:2 acceptable:1 poor:0
    explanation = models.CharField(max_length=1000,null=False)  # Sufficient:2 Acceptable Insufficient:0

    def getUserAnnotations(user_id):
        return Annotation.objects.filter(user=user_id)

    def get_num_of_annotations_per_user(user_id):
        result = Annotation.objects.values('repository_pair').filter(user=user_id).annotate(
            count=Count('repository_pair'))
        return result['repository_pair']

    def getAnnotation(user_id, pair_id):
        try:
            return Annotation.objects.get(user_id=user_id, repository_pair_id=pair_id)
        except ObjectDoesNotExist as e:
            return None

annotation-app/reposynergy/controller.py
import pandas as pd
import csv

from django.http import HttpResponse
from .models import RepositoryPair, Annotation

################# Helpers #################

def qs_to_df(qs):
    if qs is not None:
        return pd.DataFrame(list(qs.values()))
    return None

def get_repo_readme(url):
    folder = "data/readme_files" # "data/readme_files"
    path = '{}/{}.md'.format(folder, '.'.join(url.split('/')[-2:]))
    data = None#

    with open(path, 'r', encoding="utf8") as file:
        data = file.read()

    return data

################# DF Helpers #################

def _set_synergy_label(row):
    synergy_map= {1:'None', 2:'Weak', 3:'Somewhat', 4:'Strong'}
    direction_map = {0: 'None', 12: 'repo1 can benefit from repo2', 21: 'repo2 can benefit from repo1',
                     2: 'both can benefit from each others'}
    row['synergy'] = synergy_map[int(row['synergy'])] if row['synergy'] != '' else ''
    row['direction'] = direction_map[int(row['direction'])] if row['direction'] != '' else ''
    return row

################# Controller methods #################

def get_annotations_info(user_id, batch):
    print('batch: ', batch)
    repo_pair_df = qs_to_df(RepositoryPair().getBatchRepoPairs(batch))
    repo_pair_df.sort_values(['id'], inplace=True)
    repo_pair_df.set_index('id', inplace=True)

    annotation_df = qs_to_df(Annotation.getUserAnnotations(user_id)) # annotation_date,synergy, explanation
    if annotation_df is not None and len(annotation_df) > 0:
        annotation_df.set_index('repository_pair_id', inplace=True)
        repo_pair_df = repo_pair_df.join(annotation_df, how='left', rsuffix='_annotator' )
        repo_pair_df['synergy'].fillna('', inplace=True)
        repo_pair_df['explanation'].fillna('', inplace=True)
        repo_pair_df['direction'].fillna('', inplace=True)
    else:
        repo_pair_df['synergy'] = ''
        repo_pair_df['explanation'] = ''
        repo_pair_df['direction'] = ''
        repo_pair_df['annotation_date'] = None

    repo_pair_df = repo_pair_df.apply(_set_synergy_label, axis=1)
    repo_pair_df.reset_index(inplace=True)

    total = len(repo_pair_df)
    annotated = len(annotation_df) if annotation_df is not None else 0

    return repo_pair_df, total, annotated

def get_unnotated(user_id, batch):
    all_annotations, total, annotated = get_annotations_info(user_id, batch)
    unnotated_df = (all_annotations[all_annotations['synergy'] == '']).copy()
    return unnotated_df

def get_next_unnotated_pair(user_id, batch):
    unnotated_df = get_unnotated(user_id, batch)
    return unnotated_df.id.values[0] if (len(unnotated_df) > 0) else None

def get_repo_pair_info(pair_id):
    repo_pair =  RepositoryPair.objects.get(pk=pair_id)

    repo1_readme =get_repo_readme(repo_pair.repo_url1)
    repo2_readme =get_repo_readme(repo_pair.repo_url2)

    return repo1_readme, repo2_readme

#### Export
def export_to_csv(model_class):

    data = qs_to_df(model_class.objects.all())
    response = None

    if data is not None:
        meta = model_class._meta
        field_names = list(data.columns.values)

        response = HttpResponse(content_type='text/csv')
        response['Content-Disposition'] = 'attachment; filename={}.csv'.format(meta)
        writer = csv.writer(response)

        writer.writerow(field_names)
        for _, row in data.iterrows():
            row = writer.writerow([row[field] for field in field_names])

    return response

annotation-app/reposynergy/views.py
# author: relbaff
from django.contrib import messages
from django.contrib.auth.decorators import user_passes_test, permission_required
from django.shortcuts import render, redirect

from django.contrib.auth import authenticate
from django.utils import timezone
from datetime import datetime
from . import PAGES, controller, models


import pandas as pd
import csv, io

### Helper Function
def set_context(request):
    context = {
        'username': request.session['username'],
        'fullname': request.session['fullname'],
        'is_staff': request.session['is_staff'],
        'batch': request.session['batch'],
    }
    return context

def is_logged_in(request):
    return 'username' in request.session.keys() and request.session['username'] is not None

def is_batch_assigned(request):
    return 'batch' in request.session.keys() and request.session['batch'] is not None

def is_admin(request):
    return 'is_staff' in request.session.keys() and request.session['is_staff'] is True

def checkbox_value(request, key):
    return True if key in request.POST.keys() and request.POST[key] == 'on' else False
#### Views
def index(request):
    if is_logged_in(request):
        return dashboard(request)
    return render(request, PAGES.LOGIN_PAGE)


### Login
def login(request):
    if is_logged_in(request):
        return dashboard(request)

    context = {}
    username = request.POST['username']
    password = request.POST['password']

    user = authenticate(username=username, password=password)

    if user is not None:
        user.last_login = timezone.now()
        user.save()

        request.session['user_id'] = user.id
        request.session['username'] = user.username
        request.session['is_staff'] = user.is_staff
        request.session['fullname'] = ('{} {}').format(user.first_name, user.last_name)
        request.session['batch'] = user.batch

        return dashboard(request)

    else:
        context['message'] = PAGES.MESSAGE_LOGIN_FAILED
        context['message_type'] = PAGES.MESSAGE_TYPE_ALERT
        return render(request, PAGES.LOGIN_PAGE, context)


## Logout
def logout(request):
    request.session.flush()
    return render(request, PAGES.LOGIN_PAGE)


## Dashboard: shows progress for each bacth
def dashboard(request):
    if not is_logged_in(request) :
        return index(request)

    context = set_context(request)

    if is_admin(request):
        return render(request, PAGES.ADMIN_DASHBOARD_PAGE, context)

    if not is_batch_assigned(request):
        return render(request, PAGES.ERROR_PAGE)


    # get a list of all the pairs and if they are annotated or not with synergy and view with repo_pair id
    repo_pairs, total, annotated = controller.get_annotations_info(request.session['user_id'], request.session['batch'])
    context['repo_pairs'] = repo_pairs
    context['total'] = total
    context['annotated'] = annotated
    return render(request, PAGES.DASHBOARD_PAGE, context)



def annotate(request, pair_id):

    if not is_logged_in(request):
        return index(request)

    if not is_batch_assigned(request):
        return render(request, PAGES.ERROR_PAGE)
    # Grab the readme files for repo1 and repo2
    ## 1. get repo names
    readme1, readme2 = controller.get_repo_pair_info(pair_id)

    context = set_context(request)
    context['readme1'] = readme1
    context['readme2'] = readme2
    context['annotated'] = False
    context['pair_id'] = pair_id

    # check if repo exists
    annotation = models.Annotation.getAnnotation(request.session['user_id'], pair_id)
    if annotation is not None:
        context['explanation'] = annotation.explanation
        context['synergy'] = annotation.synergy
        context['direction'] = annotation.direction

    context['total'] = len(models.RepositoryPair().getBatchRepoPairs(context['batch']))
    context['annotated'] = len(models.Annotation.objects.filter(user=request.session['user_id']))


    return render(request, PAGES.ANNOTATION_PAGE, context)

def save_annotation(request):
    if  not is_logged_in(request):
        return index(request)

    if not is_batch_assigned(request):
        return render(request, PAGES.ERROR_PAGE)

    user_id = request.session['user_id']
    batch = request.session['batch']
    pair_id = request.POST['pair_id']

    synergy = request.POST['synergyQuestion']
    direction = request.POST['directionQuestion'] if 'directionQuestion' in request.POST.keys() else 0
    explanation = request.POST['explanation']

    u = models.User.objects.get(pk=user_id)
    annotation = models.Annotation.getAnnotation(user_id, pair_id)
    if annotation == None: #create
        u.annotation_set.create(repository_pair_id=pair_id, synergy=synergy, direction=direction,
                                explanation=explanation, annotation_date=datetime.now())
    else: # update
        annotation.synergy = synergy
        annotation.direction = direction
        annotation.explanation = explanation
        annotation.save()

    next_pair= controller.get_next_unnotated_pair(user_id, batch)
    if next_pair == None:
        return dashboard(request)

    return annotate(request,  next_pair)

### Admin pages: create user, upload repo-pair  and download annotations
def create_show_users(request):
    if not is_logged_in(request) or not is_admin(request):
        return index(request)

    context = set_context(request)

    if request.method != 'GET':

        user, created = models.User.objects.update_or_create(
            first_name = request.POST['firstname'],
            last_name = request.POST['lastname'],
            username=request.POST['username'],
            email = request.POST['email'],
            batch = request.POST['batch'] if not checkbox_value(request, 'staff') else None,
            is_staff =  checkbox_value(request, 'staff'),
            is_active = checkbox_value(request, 'active'),

        )
        user.set_password(request.POST['password'])
        user.save()

    context['users_data'] = models.User.objects.all()

    return render(request, PAGES.USERS_PAGES, context)

def upload_repopairs(request):
    if  not is_logged_in(request) or not is_admin(request):
        return index(request)

    context = set_context(request)

    if request.method != 'GET':
        csv_file = request.FILES['file']
        if not csv_file.name.endswith('.csv'):
            messages.error(request, "Please upload a .csv file with the following order: 'id'	"
                                    "'repo_url1'	'repo_description1'	'repo_url2'	'repo_description2'	'score'	'is_random'	'algorithm'	'batch'")
        else:
            data_set = csv_file.read().decode('UTF-8')
            io_string = io.StringIO(data_set)
            next(io_string) # skip header
            for column in csv.reader(io_string, delimiter=','):
                repopair, created = models.RepositoryPair.objects.update_or_create(
                    id = int(column[0]),
                    defaults = {
                        'repo_url1' : column[1],
                        'repo_description1' : column[2],
                        'repo_url2' : column[3],
                        'repo_description2' : column[4],
                        'score': float(column[5]),
                        'is_random': (True if column[6].strip() == 'True' else False),
                        'algorithm': column[7],
                        'batch': column[8],

                    }
                )
                repopair.save()

    context['repo_pairs_data'] = models.RepositoryPair.objects.all()
    context['count'] = len(models.RepositoryPair.objects.all())
    return render(request, PAGES.UPLOAD_REPO_PAIRS, context)


def download_annotations(request):
    if  not is_logged_in(request) or not is_admin(request):
        return index(request)
    return controller.export_to_csv(models.Annotation)

def download_users(request):
    if  not is_logged_in(request) or not is_admin(request):
        return index(request)
    return controller.export_to_csv(models.User)

def download_repo_pairs(request):
    if  not is_logged_in(request) or not is_admin(request):
        return index(request)
    return controller.export_to_csv(models.RepositoryPair)

annotation-app/reposynergy/templates/reposynergy/admin.html
{% load static %}
{% include  "reposynergy/components/header.html" %}


    <div class="container-fluid" id="main">

        <div  class="page-header container">
            <br>
            <a href="{% url 'reposynergy:upload_repopairs'  %}">View/Upload Repo Pairs</a> <br>
            <a href="{% url 'reposynergy:create_show_users'  %}">View/Add Users</a> <br><br>
            <a href="{% url 'reposynergy:download_annotations'  %}">Download Annotations</a><br>
            <a href="{% url 'reposynergy:download_users'  %}">Download Users</a><br>
            <a href="{% url 'reposynergy:download_repo_pairs'  %}">Download Repo Pairs</a><br>
        </div>
    </div>
{% include "reposynergy/components/footer.html" %}

annotation-app/reposynergy/templates/reposynergy/annotation.html
{% load static %}
{% include  "reposynergy/components/header.html" %}

<div class="articles" xmlns:synergy>

                <div  class="page-header">
                        <span><a href="{% url 'reposynergy:dashboard' %}"> << Back to Dashboard </a></span><br><br>

                    <h1>Annotate Repositories Pair </h1> <br>
                    <div class="alert alert-primary text-center" role="alert" >You annotated {{annotated}} out of {{total}} pairs</div>

                  
                </div>
<br>
            <input type="hidden" value="{{ readme1 }}" id="hidden_readme1">
            <input type="hidden" value="{{ readme2 }}" id="hidden_readme2">
          <div class="container-auto">
                  <div class="row">

                    <div  class="col-6"  >
                    <div  class="boxshadow"  >
                     <h2 >Repository 1 <i>readme</i> file</h2>
                        <hr>
                        <div class="readme"  id="readme1">

                        </div >
                        </div >


                    </div> <!-- End of col for original editorial-->
                    <div  class="col-6"  >
                    <div  class="boxshadow"  >
                     <h2 >Repository 2 <i>readme</i> file</h2>
                    <hr>
                        <div  class="readme" id="readme2">

                        </div >
                </div> <!-- End of col for summaries-->
                </div> <!-- End of col for summaries-->

                

            </div>
            <br>
              <form id="annotated-form" action="{% url 'reposynergy:save_annotation'  %}" method="post" class="needs-validation" >
                        {% csrf_token %}
                  <input type="hidden" value="{{pair_id}}" name="pair_id" id="pair_id">
              <div  class="boxshadow"  >
              <div class="row">
                  <div class=" col">
                      <h1>
                          Questions
                      </h1>
                  </div>
              </div>
              <div class="row">
                  <div class=" col-6">
                      <span class="question">1. There is synergy between the two repositories:</span> <br>
                      <small><i>I see that there is synergy between the 2 repositories:
                     they inspire a new software project that combines features of both (i.e., They have complementary features)</i> </small><br>
                      <!-- <i><small>Note: 2 repositories have complementary features when one repository can use the software features of the other repository (and vice versa)</small></i> -->
                        <div class="form-check ">
                          <input class="form-check-input" type="radio" name="synergyQuestion" id="synergyQuestion1" value="1" required {% if synergy == 1 %} checked{% endif %}>
                          <label class="form-check-label" for="synergyQuestion1">None  - <small>No complementary or common features (they solve unrelated tasks and cannot benefit from each other)</small></label>
                        </div>
                        <div class="form-check ">
                          <input class="form-check-input" type="radio" name="synergyQuestion" id="synergyQuestion2" value="2" required {% if synergy == 2 %} checked{% endif %}>
                            <label class="form-check-label" for="synergyQuestion2">Weak - <small>More common features than complementary (they both seem to solve similar tasks with minor difference in features)</small></label>
                        </div>
                        <div class="form-check ">
                          <input class="form-check-input" type="radio" name="synergyQuestion" id="synergyQuestion3" value="3" required {% if synergy == 3 %} checked{% endif %}>
                          <label class="form-check-label" for="synergyQuestion3">Somewhat - <small> Some features can be merged (using features from one repository can benefit the other)</small></label>
                        </div>
                                              <div class="form-check ">
                          <input class="form-check-input" type="radio" name="synergyQuestion" id="synergyQuestion4" value="4" required {% if synergy == 4 %} checked{% endif %}>
                          <label class="form-check-label" for="synergyQuestion4">Strong  - <small> Clear complementary features that lead to a new project (combining features from both repositories is innovative)</small></label>
                        </div>

                  </div>
                  <div class="col-6">
                      <span class="question">2. Synergy direction:</span> <br>
                         <div class="form-check ">

                          <input class="form-check-input" type="radio" name="directionQuestion" id="directionQuestion-none" value="0" required  {% if direction == 0 %} checked{% endif %}  >
                          <label class="form-check-label" for="directionQuestion-none">None</label>
                        </div>
                        <div class="form-check ">
                          <input class="form-check-input" type="radio" name="directionQuestion" id="directionQuestion-1-from-2" value="12" required  {% if direction == 12 %} checked{% endif %}>
                          <label class="form-check-label" for="directionQuestion-1-from-2">Repository 1 benefits from Repository 2</label>
                        </div>
                        <div class="form-check ">
                          <input class="form-check-input" type="radio" name="directionQuestion" id="directionQuestion-2-from-1" value="21" required  {% if direction == 21 %} checked{% endif %}>
                          <label class="form-check-label" for="directionQuestion-2-from-1">Repository 2 benefits from Repository 1</label>
                        </div>
                      <div class="form-check ">
                          <input class="form-check-input" type="radio" name="directionQuestion" id="directionQuestion-both" value="2" required  {% if direction == 2 %} checked{% endif %}>
                          <label class="form-check-label" for="directionQuestion-both">Both repositories benefit from each others</label>
                        </div>

                  </div>


              </div>

              <div class="row">
                  <div class="col-6">
                      <br>
                      <label for="explanationtextarea" class="question">3. Explanation:</label><br>
                      <i></i>
                    <textarea class="form-control" id="explanationtextarea" rows="3" name="explanation" maxlength="1000" minlength="0" placeholder="Please add a short explanation of your answer ESPECIALLY in case you think there is a potential synergy between the repositories.">{{explanation}}</textarea>
                      <br>


                  </div></div>
                   <div class="form-group">
                        <button type="submit" class="btn btn-primary btn-block">Submit</button>
                       </div>
              </div>
              </form>
        </div>
  </div>

<script src="{% static 'reposynergy/js/main.js' %}"></script>
{% include "reposynergy/components/footer.html" %}

annotation-app/reposynergy/templates/reposynergy/dashboard.html
{% load static %}
{% include  "reposynergy/components/header.html" %}

           
    <div class="container-fluid" id="main">


        <div  class="page-header container">
                        <div  class="boxshadow"  >
                                <h1>Guideline</h1>
                            <h2>Overview</h2>
                            <p>Many new projects result from novel combinations of already existing tools and techniques. This is especially the case for software development. Due to the huge amount of open source projects it is impossible to keep track of all new developments and potential synergy between projects remain undiscovered.
                            </p>

                            <p>In our project we aim to analyze GitHub repositories using data mining techniques in order to discover pairs of software projects that can <b>benefit</b> from each other,  or that can <b>inspire</b> new software projects when combined together.</p>

                                    <h2>Defining Two Repositories with Synergy </h2>
                            <p> We define two <i>diverse</i> or <i>somehow similar</i> repositories to have potential synergy if they inspire a new software project that combines features of both. </p>

                                     <h2>Questions</h2>
                                    <p>As part of our evaluation, we ask annotators (you are one of them) to annotate 30 pairs of GitHub repositories. </p>

                                     <p>For each pair, we ask you first to read the README files of the two repositories and then answer 3 questions:
                                        <ol>
                            <li>Can you imagine a new software project that is mainly based on combining software features from both?<br>
                            </li>
                            <li> If there is synergy between the pair, what is the <i>direction</i> of the synergy?

                                           <ul>
                                            <li> None </li>
                                            <li> Repository 1 benefits from Repository 2</li>
                                            <li> Repository 2 benefits from Repository 1</li>
                                            <li> Both repositories benefit from each others</li>
                                               </ul>
                                    </li>
                                    <li> Explain your answer: this a free text answer where you can either define how can the 2 repositories benefit from each others or why they can not benefit from each others. This field is optional in case there is no synergy between the 2 repositories.</li>
                                    </ol></p>
                            <h2>Annotation Tool</h2>
                            <p>Upon login, you are always redirected to this page (dashboard) where the guideline and an overview of your progress is shown.  </p>

                            <p>Please feel free to review the guidelines at any point in time. </p>

                            <p>Below, we show you a table containing all the repository pairs, your evaluation for each pair and your overall progress. When you click to <i>view</i> one pair, you will be redirected to view the two readme files of two repositories and you are asked to answer the questions and submit. Upon submission, you will be redirected to evaluate the next pair. At any time in point, you can click the top left link, <i>Back to Dashboard</i> to go back to the dahsboard.</p>

                            <p>Please finish the annotations at your own pace. Your data will be saved and you can logout and login again to continue.</p>


            <h2>Disclaimer</h2>
            Please be sure that your annotations will be used solely for research (non-commercial) purposes. The results of the annotations will be available publicly after this study is done, without revealing your identity.


                </div>   </div>



            <br />
             <div  class="dashboard">
                <h1> Overview of your Annotations </h1>
                 <br>
                {% if total == annotated %}<div class="alert alert-success  text-center" role="alert" >Thank you for completing the survey! You can still review and update your entries until the 6th of May 2020. </div>{% endif %}
                <div class="alert alert-primary text-center" role="alert" >You annotated {{annotated}} out of {{total}} repository pairs...</div>
                 <br>


                 {% if repo_pairs|length > 0 %}
            <table class="table table-hover table-responsive">
              <thead>
                <tr>
                    <th scope="col">Pair ID</th>
                  <th scope="col">Repository 1</th>
                  <th scope="col">Repository 2</th>

                  <th scope="col">Annotated</th>
                  <th scope="col">Have Synergy</th>
                  <th scope="col">Synergy Direction</th>
                  <th scope="col">Explanation</th>
                  <th scope="col"></th>
                </tr>
              </thead>
              <tbody>
            {% for pair in repo_pairs.itertuples  %}

            <tr id="{{pair.id}}" >
                 <td>{{pair.id }}</td>
                <td>{{pair.repo_description1 }}</td>
                <td>{{pair.repo_description2 }}</td>
                <td class="text-center">{% if pair.synergy != '' %}
                        <img src="{% static 'reposynergy/img/check.png' %}" height="30px" />
                    {% else %}
                        <img src="{% static 'reposynergy/img/not.png' %}" height="25px" />
                    {% endif %}
                </td>
                <td>{{pair.synergy}}</td>
                <td>{{pair.direction}}</td>
                <td>{{pair.explanation}}</td>

                <td><a href="{% url 'reposynergy:annotate' pair.id %}">view</a> </td>

            </tr>

            {% endfor%}


                  </tbody>
        </table>

                {% else %}
                <span>No repositories uploaded yet, please contact us!</span>
        {% endif %}

        </div>
        </div>
{% include "reposynergy/components/footer.html" %}

annotation-app/reposynergy/templates/reposynergy/error.html
{% load static %}
{% include  "reposynergy/components/header.html" %}


    <div class="container-fluid" id="main">


        <div  class="page-header container">
                        <div  class="boxshadow"  >
                                <h1>Error</h1>
                                <p>It seems that you were not assigned a batch!</p>
                            <p>Please contact us at roxanne.elbaff@dlr.de to fix this for you!</p>
                </div>   </div>




        </div>
{% include "reposynergy/components/footer.html" %}

annotation-app/reposynergy/templates/reposynergy/index.html
{% include  "reposynergy/components/header.html" %}


    <!-- Login Form -->

    <form action="{% url 'reposynergy:login'  %}" method="post" class="login-form">
    {% csrf_token %}
          {% if message %}<div class="alert alert-{{ message_type }}" role="alert">{{ message }}</div>{% endif %}
 <h2 class="text-center">Log in</h2>       
        <div class="form-group">
            <input type="text" class="form-control" placeholder="Username" required="required" name="username">
        </div>
        <div class="form-group">
            <input type="password" class="form-control" placeholder="Password" required="required" name="password">
        </div>
        <div class="form-group">
            <button type="submit" class="btn btn-secondary btn-block">Log in</button>
        </div>      
    </form>

{% include "reposynergy/components/footer.html" %}